/* LP- DescReader
 * STRASSER Michel - 20040428		init
 * */

#include "LPDescReader.h"
#include <glib.h>
#include <glib-object.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/xpath.h>
#include <string.h>


static GObjectClass *lpDescReader_parentClass;

static void
impl_LPDescReader_finalize(GObject *object)
{
	GList* l;
	LPDescReader *self=(LPDescReader*)object;

	for(l=self->interfaces ; l ; l=g_list_next(l))
		g_free(l->data);
	
	g_list_free(self->interfaces);
	
	lpDescReader_parentClass->finalize(object);
}

static void
LPDescReaderClass_init (LPDescReaderClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;

	lpDescReader_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_LPDescReader_finalize;
}

GType		LPDescReader_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (LPDescReaderClass),
			NULL, NULL,
			(GClassInitFunc) LPDescReaderClass_init,
			NULL, NULL,
			sizeof (LPDescReader),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"LPDescReader", &info, 0);
	}

	return type;
}

GObject* 	
LPDescReader_new			(char* file)
{
	LPDescReader* retval;
	xmlDocPtr doc;
	xmlXPathContextPtr xpath_context;
	xmlXPathObjectPtr xpath_object=NULL;
	int i, max;

	g_return_val_if_fail(file, NULL);
	
	doc=xmlParseFile(file);

	if(!doc) {
		g_critical("File %s is not a valid xml file", file);
		return NULL;
	}

	xpath_context = xmlXPathNewContext (doc);
	xpath_object = xmlXPathEval ("/desc/ig", xpath_context);
	max=xmlXPathNodeSetGetLength(xpath_object->nodesetval);

	retval=g_object_new(LP_TYPE_DESC_READER, NULL);
	retval->interfaces=NULL;

	for(i=0 ; i < max ; i++) {
		xmlNodePtr node;
		char* src;
		
		node=xmlXPathNodeSetItem(xpath_object->nodesetval, i);
		src=(char *)xmlGetProp(node, "src");

		retval->interfaces=g_list_append(retval->interfaces, g_strdup(src));
	}

	xmlXPathFreeObject(xpath_object);
	xmlXPathFreeContext(xpath_context);
	xmlFreeDoc(doc);

	return (GObject*) retval;
}

void
LPDescReader_print			(LPDescReader* self)
{
	GList* l;
	g_print("LioubovnikPython::DescReader .interfaces=[");
	
	for(l=self->interfaces ; l ; l=g_list_next(l))
		g_print("%s, ", (char*)l->data);

	g_print("]\n");
}


