/* LPFilterSession
 * STRASSER Michel - 20040211		init
 * */

#ifndef __LP_FILTER_SESSION_H__
#define __LP_FILTER_SESSION_H__

#include <glib.h>
#include <glib-object.h>
#include <liblioubliou.h>
#include <Python.h>

#define	LP_TYPE_FILTER_SESSION			(LPFilterSession_getType ())
#define LP_FILTER_SESSION(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), LP_TYPE_FILTER_SESSION, LPFilterSession))
#define LP_FILTER_SESSION_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), LP_TYPE_FILTER_SESSION, LPFilterSessionClass))
#define LP_IS_FILTER_SESSION(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							LP_TYPE_FILTER_SESSION))
#define LP_IS_FILTER_SESSION_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							LP_TYPE_FILTER_SESSION))
#define LP_FILTER_SESSION_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define LP_FILTER_SESSION_TYPE_NAME(object)	  (g_type_name (LP_FILTER_SESSION_TYPE (object)))

typedef struct _LPFilterSession	LPFilterSession;
typedef struct _LPFilterSessionClass	LPFilterSessionClass;

struct _LPFilterSession
{
	LioubovnikFilterSession		parent_instance;
	char*				portsDir;
	char*				dir;
	LiouFilterType 			filterType;
	char* 				filterName;
	PyObject*			module;
	PyObject*			mainFunc; /* borrowed */
	PyObject*			interfacesFunc; /* borrowed */
};

struct _LPFilterSessionClass
{
	LioubovnikFilterSessionClass 	parent_class;
};

G_BEGIN_DECLS

GType		
LPFilterSession_getType			(void);

GObject* 	
LPFilterSession_new			(char* portsDir,
					 char* dir, 
					 LiouFilterType filterType, 
					 char* filterName, 
					 GObject** exception);

G_END_DECLS

#endif /* __LP_FILTER_SESSION_H__ */

