/* LS - Obj
 * STRASSER Michel - 20040211		init
 * */


#include "LPObj.h"
#include "LPFilterSession.h"
#include <liblioubliou.h>
#include <glib.h>
#include <glib-object.h>

static GObjectClass *lpObj_parentClass;

static void
impl_LPObj_finalize(GObject *object)
{
	LPObj *self=(LPObj*)object;

	g_object_unref(self->lioubliou);
	g_free(self->portsDir);
	
	lpObj_parentClass->finalize(object);
}

static void
LPObjClass_init (LPObjClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	lpObj_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_LPObj_finalize;
}

GType		LPObj_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (LPObjClass),
			NULL, NULL,
			(GClassInitFunc) LPObjClass_init,
			NULL, NULL,
			sizeof (LPObj),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"LPObj", &info, 0);
	}

	return type;
}

GObject* 	
LPObj_new			(int argc,
				 char** argv,
				 char* portsDir,
				 char* appName)
{
	LPObj* retval;
	GObject* exception;

	g_return_val_if_fail(portsDir, NULL);

	retval=g_object_new(LP_TYPE_OBJ, NULL);
	
	retval->lioubliou=LiouServer_new(LPFilterSession_new, argc, argv, portsDir, appName, &exception);
	retval->portsDir=g_strdup(portsDir);

	return (GObject*) retval;
}

void
LPObj_run			(LPObj* self)
{
	GObject* exception;
	
	g_return_if_fail(LP_IS_OBJ(self));

	LiouServer_run(LIOU_SERVER(self->lioubliou), &exception);
}


