#include <Python.h>
#include "LPObj.h"
#include "IG.h"
#include <glib.h>
#define APP_NAME "SimpleApp"
#include <stdio.h>

char* path=NULL;

char*
Py_GetPath		(void)
{
	return path;
}
#if 0
static PyObject*
emb_get(PyObject *self, PyObject *args)
{
	PyObject* igP;
	char* key;
	IG* ig;
	char* value;
	PyObject* retval;
	
	g_return_val_if_fail(PyArg_ParseTuple(args, "Os", &igP, &key), NULL);
	g_return_val_if_fail(PyCObject_Check(igP), NULL);
	
	ig=PyCObject_AsVoidPtr(igP);
	g_message("key is %s", key);
	value=IG_get(ig, key);
	g_return_val_if_fail(value, NULL);
	retval=Py_BuildValue("s", value);
	//Py_DECREF(args);	
	//Py_DECREF(igP);	
	g_free(value);
	g_free(key);
    return retval;
}
#endif
static PyObject*
emb_get(PyObject *self, PyObject *args)
{
	PyObject *igP, *keyP;
	char* key;
	IG* ig;
	char* value;
	PyObject* retval;
	
	g_return_val_if_fail(PyTuple_Size(args)==2, NULL);
	igP=PyTuple_GetItem(args, 0);
	g_return_val_if_fail(PyCObject_Check(igP), NULL);
	keyP=PyTuple_GetItem(args, 1);
	g_return_val_if_fail(PyString_Check(keyP), NULL);
	
	ig=PyCObject_AsVoidPtr(igP);
	key=PyString_AsString(keyP);
	g_message("key is %s", key);
	value=IG_get(ig, key);
	g_return_val_if_fail(value, NULL);
	retval=PyString_FromString(value);
	//Py_DECREF(args);	
	//Py_DECREF(igP);	
	g_free(value);
    return retval;
}


static PyMethodDef EmbMethods[] = {
    {"get", emb_get, METH_VARARGS,
     "get a value from an Ig"},
    {NULL, NULL, 0, NULL}
};

int
main (int argc, char **argv)
{
	int retval=0;
	GObject* lsObj;

	if (argc!=3) {
		printf("USAGE: \n\tLioubovnikPython <portsDir> <appName>\n");
		return 1;
	}
	g_type_init();

	path=g_strconcat("/usr/lib/python2.3", G_SEARCHPATH_SEPARATOR_S, argv[1], NULL);
	Py_Initialize();
	Py_InitModule("emb", EmbMethods);

	lsObj=LPObj_new(argc, argv, argv[1], argv[2]);
	
	LPObj_run(LP_OBJ(lsObj));

	Py_Finalize();
	return retval;
}

